//=========================================================================//
//-------------------------------------------------------------------------//
// $Id: i2cbus.h,v 1.2 2001/04/30 20:12:49 lanconel Exp $                                                                    //
//-------------------------------------------------------------------------//
//  Copyright (C) 1998-2001  Claudio Lanconelli                            //
//                                                                         //
//  e-mail: lancos@libero.it                                               //
//  http://www.LancOS.com                                                  //
//-------------------------------------------------------------------------//
//                                                                         //
// This program is free software; you can redistribute it and/or           //
// modify it under the terms of the GNU  General Public License            //
// as published by the Free Software Foundation; either version2 of        //
// the License, or (at your option) any later version.                     //
//                                                                         //
// This program is distributed in the hope that it will be useful,         //
// but WITHOUT ANY WARRANTY; without even the implied warranty of          //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       //
// General Public License for more details.                                //
//                                                                         //
// You should have received a copy of the GNU  General Public License      //
// along with this program (see COPYING);     if not, write to the         //
// Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. //
//                                                                         //
//-------------------------------------------------------------------------//
//=========================================================================//

#ifndef	_I2CBUS_H
#define	_I2CBUS_H

#include "types.h"
#include "wait.h"
#include "rs232int.h"

class I2CBus : public Wait
{
 public:		//------------------------------- public
	I2CBus();
	virtual ~I2CBus();

	ULONG Read(int slave, UBYTE *data, ULONG length);
	ULONG Write(int slave, UBYTE const *data, ULONG length);
	
	int Start(UBYTE slave);
	int ReadByte(int ack);
	ULONG StartRead(UBYTE slave, UBYTE *data, ULONG length);
	ULONG StartWrite(UBYTE slave, UBYTE const *data, ULONG length);
	int Stop();
	int Reset();

	void Open(int port);
	void Close();

	void SetDelay(int value)
		{ if (value > 0) shot_delay = value; }
	int GetDelay() const
		{ return shot_delay; }

	int GetErrorNumber() const
		{ return I2CBus::errno; }

 protected:		//------------------------------- protected

 private:		//------------------------------- private

	int	errno;
	int	last_addr;

	int	shot_delay;
	RS232Interface rs232;

	int CheckBusy();
	int SendStart();
	int SendStop();
	int SendBitMast(int b);
	int RecBitMast();
	int SendByteMast(int by);
	int RecByteMast(int ack);

	void setSCLSDA();
	int isSCLSDAuno() const;
	void setSDA();
	void clearSDA();
	void setSCL();
	void clearSCL();
	int getSCL() const;
	int getSDA() const;
	void bitSDA(int b);
};

#endif
